#if defined _rp_homes_included
 #endinput
#endif
#define _rp_homes_included

enum RP_Home
{
	Home_ID,
	bool:Home_Sold,
	Home_PlayerID,
	Home_Price,
	String:Home_Name[128],
	Home_Zone_Entity,
	Home_Door_Entity
}

native RP_GetHomeCount();

native RP_GetHomeIDByIndex(index);
native RP_GetHomeIDByDoor(entity);
native RP_GetHomeByPlayerID(playerID);

native RP_CreateHome(String:homename[], price, instance_start, instance_end);
native RP_DeleteHome(homeID);

native RP_GetHomePlayerID(homeID);
native RP_SetHomePlayerID(homeID, playerID);

native RP_GetHomePrice(homeID);
native RP_SetHomePrice(homeID, price);

native RP_GetDoorName(homeID, String:buffer[], length_128);
native RP_SetDoorName(homeID, String:name_128[]);

native bool:RP_IsHomeSold(homeID);
native RP_SetHomeSold(homeID, bool:isSold);

native RP_GetHomeDoor(homeID);

public __pl_rp_homes_SetNTVOptional() 
{
	MarkNativeAsOptional("RP_GetHomeCount");
	MarkNativeAsOptional("RP_GetHomeID");
	
	MarkNativeAsOptional("RP_CreateHome");
	MarkNativeAsOptional("RP_DeleteHome");
	
	MarkNativeAsOptional("RP_SetHomePlayerID");
	MarkNativeAsOptional("RP_GetHomePlayerID");
	
	MarkNativeAsOptional("RP_SetHomePrice");
	MarkNativeAsOptional("RP_GetHomePrice");
	
	MarkNativeAsOptional("RP_SetHomename");
	MarkNativeAsOptional("RP_GetHomename");
	
	MarkNativeAsOptional("RP_SetHomeSold");
	MarkNativeAsOptional("RP_IsHomeSold");
	
	MarkNativeAsOptional("RP_GetHomeByPlayerID");
	
	MarkNativeAsOptional("RP_GetHomeDoor");
	MarkNativeAsOptional("RP_GetHomeZone");
}