#if defined _dice_included
 #endinput
#endif
#define _dice_included

stock reset(client)
{
	if (!IsClientInGame(client)) return;
	
	new Float:pos[3];
	new Float:angs[3];
	new clients[2];
	new UserMsg:FadeUserMsgId = GetUserMessageId("Fade");
	
	gravity(client, 1.0);
	noclip(client, false, 0.0);
	freeze(client, false, 0.0);
	speed(client, 1.0);
	godmode(client, false);
	ExtinguishEntity(client);
	ClientCommand(client, "r_screenoverlay 0");
	
	GetClientAbsOrigin(client, pos);
	GetClientEyeAngles(client, angs);
	
	angs[2] = 0.0;
	
	TeleportEntity(client, pos, angs, NULL_VECTOR);	
	
	clients[0] = client;	
	
	new Handle:message = StartMessageEx(FadeUserMsgId, clients, 1);
	
	BfWriteShort(message, 1536);
	BfWriteShort(message, 1536);
	BfWriteShort(message, (0x0001 | 0x0010));
	BfWriteByte(message, 0);
	BfWriteByte(message, 0);
	BfWriteByte(message, 0);
	BfWriteByte(message, 0);
	
	EndMessage();	
}

stock longjump(client)
{
	if (!IsClientInGame(client)) return;
	if (!IsPlayerAlive(client)) return;
	
	new Float:velocity[3];
	new Float:velocity0;
	new Float:velocity1;
	
	velocity0 = GetEntPropFloat(client, Prop_Send, "m_vecVelocity[0]");
	velocity1 = GetEntPropFloat(client, Prop_Send, "m_vecVelocity[1]");
	
	velocity[0] = (7.0 * velocity0) * (1.0 / 4.1);
	velocity[1] = (7.0 * velocity1) * (1.0 / 4.1);
	velocity[2] = 0.0;
	
	SetEntPropVector(client, Prop_Send, "m_vecBaseVelocity", velocity);
}

stock gravity(client, Float:amount)
{
	if (!IsClientInGame(client)) return;
	if (!IsPlayerAlive(client)) return;
	
	SetEntityGravity(client, amount);
}

stock item(client, type)
{
	if (!IsClientInGame(client)) return;
	if (!IsPlayerAlive(client)) return;
	
	switch(type)
	{
		case 1:
		{
			GivePlayerItem(client, "weapon_deagle");
		}
		case 2:
		{
			GivePlayerItem(client, "weapon_hegrenade");
		}
		case 3:
		{
			GivePlayerItem(client, "weapon_flashbang");
			GivePlayerItem(client, "weapon_flashbang");
		}
	}
}

stock noclip(client, bool:turnOn, Float:time)
{
	if (!IsClientInGame(client)) return;
	if (!IsPlayerAlive(client)) return;
	
	if (turnOn)
	{
		SetEntityMoveType(client, MOVETYPE_NOCLIP);
		if (time > 0) CreateTimer(time, noclipOff, client);
	}
	if (!turnOn) SetEntityMoveType(client, MOVETYPE_WALK);
}

stock freeze(client, bool:turnOn, Float:time)
{	
	if (!IsClientInGame(client)) return;
	if (!IsPlayerAlive(client)) return;
	
	if (turnOn)
	{
		SetEntityMoveType(client, MOVETYPE_NONE);
		if (time > 0) CreateTimer(time, freezeOff, client);
	}
	if (!turnOn) SetEntityMoveType(client, MOVETYPE_WALK);
}

stock health(client, amount, type)
{
	if (!IsClientInGame(client)) return;
	if (!IsPlayerAlive(client)) return;
	
	switch(type)
	{
		case 1:
		{
			SetEntityHealth(client, amount);
		}
		case 2:
		{
			SetEntityHealth(client, GetClientHealth(client) + amount);
		}
		case 3:
		{
			SetEntityHealth(client, GetClientHealth(client) - amount);
		}
	}
}

stock drunk(client)
{
	if (!IsClientInGame(client)) return;
	if (!IsPlayerAlive(client)) return;
	
	ClientCommand(client, "r_screenoverlay Effects/tp_eyefx/tp_eyefx.vmt");
}

stock drug(client)
{
	if (!IsClientInGame(client)) return;
	if (!IsPlayerAlive(client)) return;
	
	CreateTimer(1.0, drug_loop, client, TIMER_REPEAT);	
}

stock burn(client, Float:maxburntime)
{
	IgniteEntity(client, maxburntime);
}

stock speed(client, Float:speed)
{
	if (!IsClientInGame(client)) return;
	if (!IsPlayerAlive(client)) return;
	
	SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", speed); 
}

stock rocket(client)
{
	if (!IsClientInGame(client)) return;
	if (!IsPlayerAlive(client)) return;
	
	new Float:Origin[3];
	
	GetClientAbsOrigin(client, Origin);
	
	Origin[2] = Origin[2] + 20;
	
	godmode(client, true);
	shake(client, 10, 40, 25);
	
	EmitSoundToAll("weapons/rpg/rocketfire1.wav", client, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, 0.5);
	
	CreateTimer(1.0, PlayRocketSound, client);
	CreateTimer(3.1, EndRocket, client);
}

stock godmode(client, bool:turnOn)
{
	if (!IsClientInGame(client)) return;
	if (!IsPlayerAlive(client)) return;
	
	if (turnOn) SetEntProp(client, Prop_Data, "m_takedamage", 0, 1);
	if (!turnOn) SetEntProp(client, Prop_Data, "m_takedamage", 2, 1);
}

stock shake(client, time, distance, value)
{
	if (!IsClientInGame(client)) return;
	if (!IsPlayerAlive(client)) return;
	
	new UserMsg:ShakeUserMsgId = GetUserMessageId("Shake");
	
	new clients[2];
	clients[0] = client;	
	
	new Handle:message = StartMessageEx(ShakeUserMsgId, clients, 1);
	
	BfWriteByte(message, 0);
	BfWriteFloat(message, float(value));
	BfWriteFloat(message, float(distance));
	BfWriteFloat(message, float(time));
	
	EndMessage();	
}

public Action:PlayRocketSound(Handle:timer, any:client)
{
	if (!IsClientInGame(client)) return;
	if (!IsPlayerAlive(client)) return;
	
	new Float:Origin[3];
	
	GetClientAbsOrigin(client, Origin);
	
	Origin[2] = Origin[2] + 50;
	
	EmitSoundToAll("weapons/rpg/rocket1.wav", client, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, 0.5);
	
	for (new x=1; x <= 15; x++) CreateTimer(0.2*x, rocket_loop, client);
	
	TeleportEntity(client, Origin, NULL_VECTOR, NULL_VECTOR);
}

public Action:EndRocket(Handle:timer, any:client)
{
	if (!IsClientInGame(client)) return Plugin_Stop;
	if (!IsPlayerAlive(client)) return Plugin_Stop;
	
	new Float:Origin[3];
	
	GetClientAbsOrigin(client, Origin);
	
	Origin[2] = Origin[2] + 50;
	
	for (new x=1; x <= MaxClients; x++)
	{
		if (IsClientConnected(x)) StopSound(x, SNDCHAN_AUTO, "weapons/rpg/rocket1.wav");
	}
	
	EmitSoundToAll("weapons/hegrenade/explode3.wav", client, SNDCHAN_AUTO, SNDLEVEL_NORMAL, SND_NOFLAGS, 0.5);
	
	new expl = CreateEntityByName("env_explosion");
	
	TeleportEntity(expl, Origin, NULL_VECTOR, NULL_VECTOR);
	
	DispatchKeyValue(expl, "fireballsprite", "sprites/zerogxplode.spr");
	DispatchKeyValue(expl, "spawnflags", "0");
	DispatchKeyValue(expl, "iMagnitude", "1000");
	DispatchKeyValue(expl, "iRadiusOverride", "100");
	DispatchKeyValue(expl, "rendermode", "0");
	
	DispatchSpawn(expl);
	
	ActivateEntity(expl);
	
	AcceptEntityInput(expl, "Explode");
	AcceptEntityInput(expl, "Kill");
	
	godmode(client, false);
	SlapPlayer(client, 9999);
	
	return Plugin_Handled;
}

public Action:drug_loop(Handle:timer, any:client)
{
	if (!IsClientInGame(client)) return Plugin_Stop;
	
	new UserMsg:FadeUserMsgId = GetUserMessageId("Fade");
	new Float:DrugAngles[20] = {0.0, 5.0, 10.0, 15.0, 20.0, 25.0, 20.0, 15.0, 10.0, 5.0, 0.0, -5.0, -10.0, -15.0, -20.0, -25.0, -20.0, -15.0, -10.0, -5.0};

	if (!IsPlayerAlive(client))
	{
		new Float:pos[3];
		new Float:angs[3];
		new clients[2];
		
		GetClientAbsOrigin(client, pos);
		GetClientEyeAngles(client, angs);
		
		angs[2] = 0.0;
		
		TeleportEntity(client, pos, angs, NULL_VECTOR);	
		
		clients[0] = client;	
		
		new Handle:message = StartMessageEx(FadeUserMsgId, clients, 1);
		
		BfWriteShort(message, 1536);
		BfWriteShort(message, 1536);
		BfWriteShort(message, (0x0001 | 0x0010));
		BfWriteByte(message, 0);
		BfWriteByte(message, 0);
		BfWriteByte(message, 0);
		BfWriteByte(message, 0);
		
		EndMessage();	
		
		return Plugin_Stop;
	}
	
	new Float:pos[3];
	new Float:angs[3];
	new clients[2];
	
	GetClientAbsOrigin(client, pos);
	GetClientEyeAngles(client, angs);
	
	angs[2] = DrugAngles[GetRandomInt(0,100) % 20];
	
	TeleportEntity(client, pos, angs, NULL_VECTOR);

	clients[0] = client;	
	
	new Handle:message = StartMessageEx(FadeUserMsgId, clients, 1);
	
	BfWriteShort(message, 255);
	BfWriteShort(message, 255);
	BfWriteShort(message, (0x0002));
	BfWriteByte(message, GetRandomInt(0,255));
	BfWriteByte(message, GetRandomInt(0,255));
	BfWriteByte(message, GetRandomInt(0,255));
	BfWriteByte(message, 128);
	
	EndMessage();	
		
	return Plugin_Handled;
}

public Action:rocket_loop(Handle:timer, any:client)
{
	if (!IsClientInGame(client)) return Plugin_Stop;
	if (!IsPlayerAlive(client)) return Plugin_Stop;
	
	new Float:velocity[3];
	
	velocity[2] = 300.0;
	
	TeleportEntity(client, NULL_VECTOR, NULL_VECTOR, velocity);
	
	return Plugin_Handled;
}

public Action:noclipOff(Handle:timer, any:client)
{
	noclip(client, false, 0.0);
	
	return Plugin_Handled;
}

public Action:freezeOff(Handle:timer, any:client)
{
	freeze(client, false, 0.0);
	
	return Plugin_Handled;
}