#include "roleplay/roleplay"

#define PL_NAME		"RP_HUD"

new bool:g_LateLoaded;

new String:zone[MAXPLAYERS+1][128];
new String:zoneGroup[MAXPLAYERS+1][128];

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	return APLRes_Success;
}

public OnMapStart() 
{
	// Perform action if plugin is late loaded
	if(g_LateLoaded)
	{
		g_LateLoaded = false;
	}
	
	CreateTimer(0.1, HUDTimer_CSGO, _, TIMER_FLAG_NO_MAPCHANGE|TIMER_REPEAT);
}

public Action:HUDTimer_CSGO(Handle:timer)
{
	for (new client = 1; client <= MaxClients; client++)
	{
		if (IsClientInGame(client))
			UpdateHUD_CSGO(client);
	}

	return Plugin_Continue;
}

public MapZone_OnClientEnterZone(client, const String:sZoneGroup[], const String:sZoneName[])
{
	Format(zone[client], sizeof(zone[]), "%s", sZoneGroup);
	Format(zoneGroup[client], sizeof(zoneGroup[]), "%s", sZoneGroup);
}

public MapZone_OnClientLeaveZone(client,const String:sZoneGroup[], const String:sZoneName[])
{
	Format(zone[client], sizeof(zone[]), "Unknown");
	Format(zoneGroup[client] ,sizeof(zoneGroup[]), "Unknown");
}

UpdateHUD_CSGO(client)
{
	new todo_different_hud_types;
	new todo_prio_system_for_center_text;
	new todo_door_security_helper;
	new todo_door_crack_helper;
	new todo_npc_info;
	new todo_body_info; 
	
	new crime = 0;
	new bounty = 0;
	crime = RP_GetCrime(client);
	bounty = RP_GetBounty(client);
	
	new String:centerText[512];
	
	//Change Font
	Format(centerText, sizeof(centerText), "%s<font face='toolbox' size='20'>", centerText);
	
	//First Line
	Format(centerText, sizeof(centerText), "%sMoney:<font color='#FF8A00'>%d$</font>", centerText , RP_GetMoney(client));
	
	Format(centerText, sizeof(centerText), "%s\tBank:<font color='#FF8A00'>%d$</font>", centerText, RP_GetMoneyBank(client));
	
	//Secound Line
	Format(centerText, sizeof(centerText), "%s\n", centerText);
	
	//Format(centerText, sizeof(centerText), "%sZone:<font color='#FF8A00'>%s</font>", centerText,zone[client]);
	
	//Format(centerText, sizeof(centerText), "%s\tZonegroup:<font color='#FF8A00'>%s</font>", centerText, zoneGroup[client]);
	
	Format(centerText, sizeof(centerText), "%sCrime:<font color='#FF8A00'>%d</font>", centerText,crime);
	
	Format(centerText, sizeof(centerText), "%s\tBounty:<font color='#FF8A00'>%d</font>", centerText,bounty);
	
	//Secound Line
	Format(centerText, sizeof(centerText), "%s\n", centerText);
	
	Format(centerText, sizeof(centerText), "%sWage:<font color='#FF8A00'>50$</font>", centerText);
	
	Format(centerText, sizeof(centerText), "%s\tJob:<font color='#FF8A00'>Unempolyed</font>", centerText, RP_GetMoneyBank(client));
	
	//Close Font Tag
	Format(centerText, sizeof(centerText), "%s</font>", centerText);
	
	PrintHintText(client, centerText);
}