#include "roleplay/roleplay"

#define PL_NAME		"RP_DOOR_DEFAULT"
#define DEFAULT_DOOR_INTERACTION_RANGE 100.0

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	RegPluginLibrary(PL_NAME);
	return APLRes_Success;
}

public RP_OnDoorLoaded(doorID,buildingType)
{
	if(buildingType == BD_Default)
	{
		RP_UnlockDoor(doorID);
	}
}

public RP_OnDoorUse(doorID,buildingType,client,Float:distance)
{
	if(buildingType == BD_Default)
	{
		if(0 >= client || client > MaxClients + 1)
			return;
		
		if(!IsClientInGame(client))
			return;
		
		if(!IsPlayerAlive(client))
			return;
		
		if (RP_IsValidLinearDoorEnt(RP_GetDoorEntity(doorID)) && distance <= DEFAULT_DOOR_INTERACTION_RANGE)
			RP_ToggleOpenDoor(doorID);
	}
}