#include "roleplay/roleplay"

#define PL_NAME		"RP_LOCALVOICE"

#define MAX_DIST    600

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	RegPluginLibrary(PL_NAME);
	return APLRes_Success;
}

public OnPluginStart()
{
	CreateTimer(0.1, Timer_UpdateListeners, _, TIMER_REPEAT);
}

public Action:Timer_UpdateListeners(Handle:timer)
{
    for (new client = 1; client<=GetMaxClients(); client++)
	{
        if(!IsClientInGame(client))
            continue;
        
        if(IsPlayerAlive(client))
            CheckPlayerRadius(client);
        else  PlayerIsDead(client);
    }
}

public CheckPlayerRadius(client)
{
    for (new i = 1; i <= GetMaxClients() ; i++)
	{
        if(!IsClientInGame(i) || !Client_IsValid(i) || !IsPlayerAlive(i))
            continue;
        if(!IsClientInGame(client) || !Client_IsValid(client) || !IsPlayerAlive(client))
            continue;
        if(i == client)
            continue;
        
        if(Entity_GetDistance(client, i) <= MAX_DIST && IsPlayerAlive(i))
            SetListenOverride(client, i, Listen_Yes);
        else SetListenOverride(client, i, Listen_No);
    }
}

public PlayerIsDead(client)
{
    for (new i = 1; i <= GetMaxClients() ; i++)
	{
        if(!Client_IsValid(i))
            continue;
        if(i == client) 
            continue;
		
        SetListenOverride(client, i, Listen_No);
    }
}