#include "roleplay/roleplay"

#define PL_NAME		"RP_ITEMS_TYPE"

new bool:g_LateLoaded;

/* Database */

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	CreateNative("RP_UseTypeItem", Native_UseTypeItem);
	
	return APLRes_Success;
}

public OnPluginStart()
{
	if(g_LateLoaded)
	{
		
	}
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

bool:UseTypeItem(client, itemID)
{
	decl String:sFeatures[128], String:sSettings[128];
	
	RP_GetItemFeatures(itemID, sFeatures, 128);
	RP_GetItemSettings(itemID, sSettings, 128);
	
	decl String:sFeature[5][128], String:sSetting[5][128];
	
	new iFeatures = ExplodeString(sFeatures, ":", sFeature, sizeof(sFeature), sizeof(sFeatures));
	new iSettings = ExplodeString(sSettings, ":", sSetting, sizeof(sSetting), sizeof(sSettings));
	
	if(iFeatures != iSettings)
	{
		LogError("%s [%s] itemID %d reported on UseTypeItem: Number of features and settings doesn't match (F:%d/S:%d)", PL_PRE_N, PL_NAME, iFeatures, iSettings);
		return false;
	}
	
	new bool:used;
	
	for (new i = 0; i < MAX_ITEM_SETTINGS; i++)
	{
		if(StrEqual(sFeature[i], "feature_name"))
		{
			//Do stuff and if success set used = true
		}
	}
	
	if(used) 
	{
		RP_UsedPlayerInventoryItem(client, itemID, 1);
		return true;
	}
	else CPrintToChat(client, "%s There is no reason to use this item now.", PL_PRE);
	
	return false;
}

/* Natives */

public Native_UseTypeItem(Handle:plugin, numParams)
{
	return UseTypeItem(GetNativeCell(1), GetNativeCell(2));
}