#include "roleplay/roleplay"

#define PL_NAME		"RP_TICK"
#define INTERVAL 1.0

new bool:g_LateLoaded;


/* Database */
new Handle:g_hSQL;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	return APLRes_Success;
}

public OnPluginStart()
{
	if(g_LateLoaded)
	{
		g_hSQL = Handle:RP_GetSql();
		
		if(g_hSQL != INVALID_HANDLE)
			SQLConnectionReady();
		
		g_LateLoaded = false;
	}
	CreateTimer(INTERVAL, Timer_Main, _, TIMER_REPEAT);
}

public RP_OnSqlConnected(Handle:db)
{
	g_hSQL = db;
	SQLConnectionReady();
}

public RP_OnSqlStop()
{
	g_hSQL = INVALID_HANDLE;
}

SQLConnectionReady()
{
	//Database is now ready to use
}

public RP_OnPlayerReady(client, playerID, bool:create)
{
	//PlayerID is now cached
}

public Action:Timer_Main(Handle:timer, any:data)
{
	if(g_hSQL == INVALID_HANDLE)
		return Plugin_Continue;
	
	for (new client = 1; client < MAXPLAYERS ; client++)
	{
		if (!IsClientInGame(client))
			continue;
		
		if (!IsPlayerAlive(client))
			continue;
		
		if(RP_IsClientInJail(client))
		{
			if(RP_ClientGetTimeInJail(client) == 0)
			{
				RP_ClientUnsetJail(client);
			}
			else
			{
				RP_ClientDecJailTime(client);
			}
		}
	}
	
	return Plugin_Continue;
}