#if defined _rp_building_appartmenthouse_doors_included
 #endinput
#endif
#define _rp_building_appartmenthouse_doors_included

enum RP_Appartments
{
	Appartment_ID,
	bool:Appartment_Sold,
	Appartment_PlayerID,
	Appartment_Price,
	Appartment_MaxInh,
	Building_ID,
	String:Appartment_Roomnumber[16]
}

enum RP_AppartmentDoors
{
	App_Door_ID,
	App_ID
}

native RP_GetAppartmentCount();

native RP_GetAppartmentIDByIndex(index);
native RP_GetAppartmentIDByPlayerID(playerID);

native RP_CreateAppartment(price, maxinhibitans, buildingID, String:roomAdress[]);
native RP_DeleteAppartment(AppartmentID);

native RP_GetAppartmentPlayerID(AppartmentID);
native RP_SetAppartmentPlayerID(AppartmentID, playerID);

native RP_GetAppartmentPrice(AppartmentID);
native RP_SetAppartmentPrice(AppartmentID, price);

native bool:RP_IsAppartmenSold(AppartmentID);
native RP_SetAppartmentSold(AppartmentID, bool:isSold);

native RP_GetAppartmentMaxInh(AppartmentID);
native RP_SetAppartmentMaxInh(AppartmentID, new_max);

native RP_GetAppartmentbuildingID(AppartmentID);
native RP_SetAppartmentbuildingID(AppartmentID, new_buildingID);

native RP_GetAppartmentRoomnumber(AppartmentID, String:new_roomAdress[], length_16);
native RP_SetAppartmentRoomnumber(AppartmentID, String:new_roomAdress[]);

native RP_GetAppartmentDoors(AppartmentID);//#Doors of Appartment

native RP_SetAppartmentDoor(DoorID,AppartmentID);
native RP_GetDoorAppartmentID(DoorID);
native RP_DeleteAppartmentDoor(DoorID);

native RP_GetAppartmentDoorsCount(); //#All Doors in Appartments
native RP_GetAppartmentDoorIDByIndex(index);
native RP_GetAppartmentDoorAppIDByIndex(index);

native RP_SellAppartment(AppartmentID);

public __pl_rp_building_appartmenthouse_doors_SetNTVOptional() 
{
	MarkNativeAsOptional("RP_GetAppartmentCount");
	
	MarkNativeAsOptional("RP_CreateAppartment");
	MarkNativeAsOptional("RP_DeleteAppartment");
	
	MarkNativeAsOptional("RP_SetAppartmentPlayerID");
	MarkNativeAsOptional("RP_GetAppartmentPlayerID");
	
	MarkNativeAsOptional("RP_SetAppartmentPrice");
	MarkNativeAsOptional("RP_GetAppartmentPrice");
	
	MarkNativeAsOptional("RP_SetAppartmentSold");
	MarkNativeAsOptional("RP_IsAppartmenSold");
	
	MarkNativeAsOptional("RP_GetAppartmentIDByIndex");
	MarkNativeAsOptional("RP_GetAppartmentIDByPlayerID");
	
	MarkNativeAsOptional("RP_GetAppartmentMaxInh");
	MarkNativeAsOptional("RP_SetAppartmentMaxInh");
	
	MarkNativeAsOptional("RP_GetAppartmentbuildingID");
	MarkNativeAsOptional("RP_SetAppartmentbuildingID");
	
	MarkNativeAsOptional("RP_GetAppartmentRoomnumber");
	MarkNativeAsOptional("RP_SetAppartmentRoomnumber");
	
	MarkNativeAsOptional("RP_GetAppartmentDoors");
	
	MarkNativeAsOptional("RP_SetAppartmentDoor");
	MarkNativeAsOptional("RP_GetDoorAppartmentID");
	MarkNativeAsOptional("RP_DeleteAppartmentDoor");
	
	MarkNativeAsOptional("RP_GetAppartmentDoorsCount");
	MarkNativeAsOptional("RP_GetAppartmentDoorIDByIndex");
	MarkNativeAsOptional("RP_GetAppartmentDoorAppIDByIndex");
	
	MarkNativeAsOptional("RP_SellAppartment");
}