#include "roleplay/roleplay"

#define PL_NAME		"RP_FURNITURE_OPERATIONS_MENU"

new g_iSelected[MAXPLAYERS+1];
new bool:g_iPositive[MAXPLAYERS+1];

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	RegPluginLibrary(PL_NAME);
	return APLRes_Success;
}

public OnPluginStart()
{
	RegConsoleCmd("sm_furniture", Command_Furniture);
	RegConsoleCmd("sm_furni", Command_Furniture);
}

public Action:Command_Furniture(client, args)
{
	if(0 > client && client > MaxClients)
		return Plugin_Handled;
	
	if(!IsClientInGame(client))
		return Plugin_Handled;
	
	if(!IsPlayerAlive(client))
		return Plugin_Handled;
	
	Menu_Furniture(client);
	
	return Plugin_Handled;
}

Menu_Furniture(client)
{
	new Handle:menu = CreateMenu(MenuHandler_Furniture);
	SetMenuTitle(menu, "Furniture Operations");

	AddMenuItemEx(menu, false, "0", "Rotate X");
	AddMenuItemEx(menu, false, "1", "Rotate Y");
	AddMenuItemEx(menu, false, "2", "Rotate Z");
	AddMenuItemEx(menu, false, "3", "Set Rotation X");
	AddMenuItemEx(menu, false, "4", "Set Rotation Y");
	AddMenuItemEx(menu, false, "5", "Set Rotation Z");
	AddMenuItemEx(menu, false, "6", "Move X");
	AddMenuItemEx(menu, false, "7", "Move Y");
	AddMenuItemEx(menu, false, "8", "Move Z");

	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_Furniture(Handle:menu, MenuAction:action, client, param2)
{
	if(0 > client && client > MaxClients)
		return;
	
	if(!IsClientInGame(client))
		return;
	
	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		
		if(found)
		{
			new selection = StringToInt(info);
			if(selection < 3 || selection > 5)
				Menu_Rotation(client, selection);
			else
				Menu_SetRotation(client, selection);
			return;
		}
	}
}

Menu_Rotation(client, selection)
{	
	g_iSelected[client] = selection;

	new Handle:menu = CreateMenu(MenuHandler_OperationSelect);
	if(selection ==  0)
		SetMenuTitle(menu, "Rotate Entity X-Axis");
	else if(selection ==  1)
		SetMenuTitle(menu, "Rotate Entity Y-Axis");
	else if(selection ==  2)
		SetMenuTitle(menu, "Rotate Entity Z-Axis");
	else if(selection ==  6)
		SetMenuTitle(menu, "Move Entity X-Axis");
	else if(selection ==  7)
		SetMenuTitle(menu, "Move Entity Y-Axis");
	else if(selection ==  8)
		SetMenuTitle(menu, "Move Entity Z-Axis");
	
	AddMenuItemEx(menu, false, "mainmenu", "Back to Menu");
	AddMenuItemEx(menu, false, "positive", "%s" , g_iPositive[client] ? "Positiv" : "Negativ");
	AddMenuItemEx(menu, false, "0.1", "%s0.1",g_iPositive[client] ? "+" : "-");
	AddMenuItemEx(menu, false, "1.0", "%s1",g_iPositive[client] ? "+" : "-");
	AddMenuItemEx(menu, false, "10.0", "%s10",g_iPositive[client] ? "+" : "-");
	AddMenuItemEx(menu, false, "100.0", "%s100",g_iPositive[client] ? "+" : "-");
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_OperationSelect(Handle:menu, MenuAction:action, client, param2)
{
	if(0 > client && client > MaxClients)
		return;

	if(!IsClientInGame(client))
		return;

	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		new Float:selectedDistance;
		
		if(StrEqual(info, "mainmenu"))
		{
			Menu_Furniture(client);
			return;
		}
		
		if(StrEqual(info, "positive"))
		{
			g_iPositive[client] = !g_iPositive[client];
			Menu_Rotation(client,g_iSelected[client]);
		}
		
		decl ent;
		ent = GetClientAimTarget(client,false);
	
		decl String:className[32];
		GetEdictClassname(ent, className, 32);
		
		if(found && (StrContains(className, "prop_", false) != -1) && IsValidEntity(ent))
		{
			selectedDistance = StringToFloat(info);
			if(g_iSelected[client] == 0)
			{
				if(g_iPositive[client])
					Entity_RotateProp(ent,selectedDistance,0.0,0.0,false);
				else
					Entity_RotateProp(ent,-selectedDistance,0.0,0.0,false);
				
				Menu_Rotation(client,g_iSelected[client]);
			}
			else if(g_iSelected[client] == 1)
			{
				if(g_iPositive[client])
					Entity_RotateProp(ent,0.0,selectedDistance,0.0,false);
				else
					Entity_RotateProp(ent,0.0,-selectedDistance,0.0,false);
				
				Menu_Rotation(client,g_iSelected[client]);
			}
			else if(g_iSelected[client] == 2)
			{
				if(g_iPositive[client])
					Entity_RotateProp(ent,0.0,0.0,selectedDistance,false);
				else
					Entity_RotateProp(ent,0.0,0.0,-selectedDistance,false);
				
				Menu_Rotation(client,g_iSelected[client]);
			}
			else if(g_iSelected[client] == 6)
			{
				if(g_iPositive[client])
					Entity_PositionProp(ent,selectedDistance,0.0,0.0);
				else
					Entity_PositionProp(ent,-selectedDistance,0.0,0.0);
				
				Menu_Rotation(client,g_iSelected[client]);
			}
			else if(g_iSelected[client] == 7)
			{
				if(g_iPositive[client])
					Entity_PositionProp(ent,0.0,selectedDistance,0.0);
				else
					Entity_PositionProp(ent,0.0,-selectedDistance,0.0);
				
				Menu_Rotation(client,g_iSelected[client]);
			}
			else if(g_iSelected[client] == 8)
			{
				if(g_iPositive[client])
					Entity_PositionProp(ent,0.0,0.0,selectedDistance);
				else
					Entity_PositionProp(ent,0.0,0.0,-selectedDistance);
				
				Menu_Rotation(client,g_iSelected[client]);
			}
		}
		else
		{
			Menu_Rotation(client,g_iSelected[client]);
		}
	}
}

Menu_SetRotation(client, selection)
{	
	g_iSelected[client] = selection;

	new Handle:menu = CreateMenu(MenuHandler_SetRoatationSelect);
	if(selection ==  3)
		SetMenuTitle(menu, "Set Rotation Entity X-Axis");
	else if(selection ==  4)
		SetMenuTitle(menu, "Set Rotation Entity Y-Axis");
	else if(selection ==  5)
		SetMenuTitle(menu, "Set Rotation Entity Z-Axis");
	
	AddMenuItemEx(menu, false, "mainmenu", "Back to Menu");
	AddMenuItemEx(menu, false, "0.0", "0 Grad");
	AddMenuItemEx(menu, false, "45.0", "45 Grad");
	AddMenuItemEx(menu, false, "90.0", "90 Grad");
	AddMenuItemEx(menu, false, "135.0", "135 Grad");
	AddMenuItemEx(menu, false, "180.0", "180 Grad");
	AddMenuItemEx(menu, false, "225.0", "225 Grad");
	AddMenuItemEx(menu, false, "270.0", "270 Grad");
	AddMenuItemEx(menu, false, "315.0", "315 Grad");
	
	SetMenuExitButton(menu, true);
	DisplayMenu(menu, client, MENU_TIME_FOREVER);
}

public MenuHandler_SetRoatationSelect(Handle:menu, MenuAction:action, client, param2)
{
	if(0 > client && client > MaxClients)
		return;

	if(!IsClientInGame(client))
		return;

	if(!IsPlayerAlive(client))
		return;
	
	if (action == MenuAction_Select)
	{
		decl String:info[100], String:info2[100];
		new bool:found = GetMenuItem(menu, param2, info, sizeof(info), _, info2, sizeof(info2));
		new Float:selectedDistance;
		
		if(StrEqual(info, "mainmenu"))
		{
			Menu_Furniture(client);
			return;
		}
		
		decl ent;
		ent = GetClientAimTarget(client,false);
	
		decl String:className[32];
		GetEdictClassname(ent, className, 32);

		if(found && (StrContains(className, "prop_", false) != -1) && IsValidEntity(ent))
		{
			selectedDistance = StringToFloat(info);
			CPrintToChat(client, "%f",selectedDistance);
			if(g_iSelected[client] == 3)
			{
				Entity_SetXProp(ent,selectedDistance);
				Menu_SetRotation(client,g_iSelected[client]);
			}
			else if(g_iSelected[client] == 4)
			{
				Entity_SetYProp(ent,selectedDistance);
				Menu_SetRotation(client,g_iSelected[client]);
			}
			else if(g_iSelected[client] == 5)
			{
				Entity_SetZProp(ent,selectedDistance);
				Menu_SetRotation(client,g_iSelected[client]);
			}
		}
	}
}
