#include "roleplay/roleplay"

#define PL_NAME		"RP_HUD"
#define DISPLAYTIME 0.25
#define MAX_HUD_DISTANCE 400.0

new bool:g_LateLoaded;

public Plugin:myinfo = 
{
	name = PL_NAME,
	author = PL_AUTHOR,
	description = "",
	version = PL_VERSION,
	url = PL_URL
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	g_LateLoaded = late;
	RegPluginLibrary(PL_NAME);
	
	return APLRes_Success;
}

public OnMapStart() 
{
	// Perform action if plugin is late loaded
	if(g_LateLoaded)
	{
		g_LateLoaded = false;
	}
	
	CreateTimer(DISPLAYTIME, HUDTimer_CSGO, _, TIMER_FLAG_NO_MAPCHANGE|TIMER_REPEAT);
}

public Action:HUDTimer_CSGO(Handle:timer)
{
	for (new client = 1; client <= MaxClients; client++)
	{
		if (IsClientInGame(client))
			UpdateHUD_CSGO(client);
	}

	return Plugin_Continue;
}

UpdateHUD_CSGO(client)
{
	if(0 > client && client < MaxClients + 1)
		return;
	
	if (!IsClientInGame(client))
		return;
		
	if(!IsPlayerAlive(client) || IsClientObserver(client))
	{
		return;
	}
	
	new todo_door_security_helper;
	new todo_door_crack_helper;
	new todo_body_info;
	
	decl crime, bounty, entity;
	decl Float:clientOrigin[3];
	decl Float:doorOrigin[3];
	new Float:distance = 0.0;
	
	entity = GetClientAimTarget(client, false);
	Entity_GetAbsOrigin(client,clientOrigin);
	
	if(entity != -1)
	{
		Entity_GetAbsOrigin(entity,doorOrigin);
		distance = GetVectorDistance(clientOrigin, doorOrigin);
	}
	
	crime = RP_GetCrime(client);
	bounty = RP_GetBounty(client);
	
	new String:centerText[512];
	
	//Change Font
	Format(centerText, sizeof(centerText), "<font face='toolbox' size='20'>");
	if(RP_IsClientCuffed(client))
	{
		Format(centerText, sizeof(centerText), "%s Cuffed: %d / Jailed: %d \n",centerText, RP_IsClientCuffed(client) , RP_IsClientJailed(client));	
		Format(centerText, sizeof(centerText), "%s Time in Jail: %d / Jailed by : %d \n", centerText,RP_GetPlayerJailTime(client),RP_GetPlayerJailedByID(client));
	}
	if(distance <= MAX_HUD_DISTANCE && entity != -1)
	{
		if(0 < entity && entity < MaxClients + 1)
		{
			if(IsClientInGame(entity) && IsPlayerAlive(entity))
			{
				new playerID = RP_GetPlayerID(entity);
				new String:playerName[64];
				
				GetClientName(entity, playerName, sizeof(playerName));
				
				Format(centerText, sizeof(centerText), "%s Name: %s\n", centerText , playerName);	
				Format(centerText, sizeof(centerText), "%s Crime: %d\n", centerText, RP_GetCrime(playerID));
				Format(centerText, sizeof(centerText), "%s Job: Unemployed", centerText);
			}
		}
		else if(RP_GetNpcID(entity) >= 0)
		{
			new npcID = RP_GetNpcID(entity);
			new String:npcName[64];
			
			RP_GetNpcName(npcID, npcName, sizeof(npcName));
			
			Format(centerText, sizeof(centerText), "%s Name: %s\n", centerText , npcName);	
			Format(centerText, sizeof(centerText), "%s Type: %d\n", centerText, RP_GetNpcType(npcID));
			Format(centerText, sizeof(centerText), "%s Team: %d", centerText, RP_GetNpcTeam(npcID));
		}
		else if(RP_IsValidDoorEnt(entity))
		{
			decl String:sDoorName[64];
			decl String:sBuildingName[64];
			decl String:clsname[64];
			decl doorID,doorType,doorBuildingID,buildingType;
			
			doorID = RP_GetDoorIDbyEntity(entity);
			doorType = RP_GetDoorType(doorID);
			doorBuildingID = RP_GetDoorBuildingID(doorID);
			buildingType = RP_GetBuildingType(doorBuildingID);
			
			GetEntityClassname(entity, clsname, sizeof(clsname));
			RP_GetDoorName(doorID,sDoorName,sizeof(sDoorName));	
			RP_GetBuildingName(doorBuildingID,sBuildingName, sizeof(sBuildingName));
			
			if(doorID != -1)
			{
				Format(centerText, sizeof(centerText), "<font face='toolbox' size='30'>");
				
				if(buildingType == BD_Default)
				{
					return;
				}
				else if(buildingType == BD_PoliceDepartment)
				{
					decl String:typenameBuffer[64];
					RP_GetPDDoorTypeName(doorType,typenameBuffer,sizeof(typenameBuffer));
					Format(centerText, sizeof(centerText), "%s %s \n", centerText , sBuildingName);
					Format(centerText, sizeof(centerText), "%s %s", centerText , typenameBuffer);
				}
				else if(buildingType == BD_AppartmentHouse)
				{
					decl appartmentID;			
					appartmentID = RP_GetDoorAppartmentID(doorID);
					decl bool:isSold;
					isSold = RP_IsAppartmenSold(appartmentID);
					
					if(doorType == Door_AppartmentHouse_Entrance)
					{
						Format(centerText, sizeof(centerText), "%s %s \n", centerText , sBuildingName);
						Format(centerText, sizeof(centerText), "%s Entrance", centerText , sDoorName);
					}
					else
					{
						decl String:appRoomAdress[16];
						RP_GetAppartmentRoomnumber(appartmentID, appRoomAdress, sizeof(appRoomAdress));
						if(isSold)
						{
							Format(centerText, sizeof(centerText), "%s %s \n", centerText , sBuildingName);
							Format(centerText, sizeof(centerText), "%s [%s] %s", centerText , appRoomAdress, sDoorName);
						}
						else
						{
							Format(centerText, sizeof(centerText), "%s %s \n", centerText , sBuildingName);
							Format(centerText, sizeof(centerText), "%s [%s] For Sale : %d$", centerText, appRoomAdress, RP_GetAppartmentPrice(appartmentID));
						}
					}
				}
				else if(buildingType == BD_Shop)
				{
					Format(centerText, sizeof(centerText), "%s %s \n", centerText , sBuildingName);
					Format(centerText, sizeof(centerText), "%s %s", centerText, doorType ? "Staff" : "Entrance");
				}
				else if(buildingType == BD_Bank)
				{
					Format(centerText, sizeof(centerText), "%s %s \n", centerText , sBuildingName);
					Format(centerText, sizeof(centerText), "%s %s", centerText, doorType ? "Staff" : "Entrance");
				}
				else
				{
					decl String:typenameBuffer[64];
					RP_GetBuildingTypeName(doorBuildingID, typenameBuffer, sizeof(typenameBuffer));
					Format(centerText, sizeof(centerText), "%s %s / %s \n", centerText , sDoorName, sBuildingName);	
					Format(centerText, sizeof(centerText), "%s Doortype: %s / %s", centerText, typenameBuffer,clsname);
				}			
			}
		}
	}
	else
	{		
		//First Line
		Format(centerText, sizeof(centerText), "%sMoney: %d$ ", centerText , RP_GetMoney(client));
		
		Format(centerText, sizeof(centerText), "%s\tBank: %d$ ", centerText, RP_GetMoneyBank(client));
		
		//Secound Line
		Format(centerText, sizeof(centerText), "%s\n", centerText);
		
		Format(centerText, sizeof(centerText), "%sCrime: %d", centerText,crime);
		
		Format(centerText, sizeof(centerText), "%s\tBounty: %d", centerText,bounty);
		
		//Third Line
		Format(centerText, sizeof(centerText), "%s\n", centerText);
		
		Format(centerText, sizeof(centerText), "%sWage: 50$", centerText);
		
		Format(centerText, sizeof(centerText), "%s\tJob: Unempolyed", centerText, RP_GetMoneyBank(client));
	}
	
	//Close Font Tag
	Format(centerText, sizeof(centerText), "%s</font>", centerText);
	
	PrintHintText(client, centerText);
}